//#property copyright ""
//#property link      ""

#property indicator_chart_window

extern int NumberOfDays = 25;
extern bool ShowFutureZone = true;
extern int NofFutureDays = 5;
extern bool Plot_Zone_1 = False;
extern string Begin_1 = "01:00";
extern string End_1 = "02:30";
extern color Color_1 = 8881808;
extern bool Plot_Zone_2 = false;
extern string Begin_2 = "03:00";
extern string End_2 = "06:00";
extern color Color_2 = 8881808;
extern bool Plot_Zone_3 = TRUE;
extern string Begin_3 = "08:00";
extern string End_3 = "9:30";
extern color Color_3 = 9471623;
extern bool Plot_Zone_4 = TRUE;
extern string Begin_4 = "9:30";
extern string End_4 = "11:30";
extern color Color_4 = 8881808;
extern bool Plot_Zone_5 = false;
extern string Begin_5 = "12:00";
extern string End_5 = "16:00";
extern color Color_5 = 8421504;
extern bool Plot_Zone_6 = false;
extern string Begin_6 = "20:00";
extern string End_6 = "22:00";
extern color Color_6 = 8881808;
extern bool HighRange = FALSE;


datetime lNextDay;
int i;


///=====================================

void init()
{
}

///=====================================

void deinit()
{
   DeleteObjects();
   Comment("");
}


///=====================================


void CreateObjects(string a_name_0, color a_color_8)
{
   ObjectCreate(a_name_0, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
   ObjectSet(a_name_0, OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet(a_name_0, OBJPROP_COLOR, a_color_8);
   ObjectSet(a_name_0, OBJPROP_BACK, TRUE);
}

///=====================================

void DeleteObjects()
{
   for (int l_count_0 = 0; l_count_0 < NumberOfDays; l_count_0++)
   {
      ObjectDelete("PWT1" + l_count_0);
      ObjectDelete("PWT2" + l_count_0);
      ObjectDelete("PWT3" + l_count_0);
      ObjectDelete("PWT4" + l_count_0);
      ObjectDelete("PWT5" + l_count_0);
      ObjectDelete("PWT6" + l_count_0);
   }
   for (l_count_0 = 1; l_count_0 <= NofFutureDays; l_count_0++)
   {
      ObjectDelete("PWT01" + l_count_0);
      ObjectDelete("PWT02" + l_count_0);
      ObjectDelete("PWT03" + l_count_0);
      ObjectDelete("PWT04" + l_count_0);
      ObjectDelete("PWT05" + l_count_0);
      ObjectDelete("PWT06" + l_count_0);
   }
}

///=====================================

void start()
{
   DeleteObjects();
   for (int l_count_0 = 0; l_count_0 < NumberOfDays; l_count_0++)
   {
      if (Plot_Zone_1) CreateObjects("PWT1" + l_count_0, Color_1);
      if (Plot_Zone_2) CreateObjects("PWT2" + l_count_0, Color_2);
      if (Plot_Zone_3) CreateObjects("PWT3" + l_count_0, Color_3);
      if (Plot_Zone_4) CreateObjects("PWT4" + l_count_0, Color_4);
      if (Plot_Zone_5) CreateObjects("PWT5" + l_count_0, Color_5);
      if (Plot_Zone_6) CreateObjects("PWT6" + l_count_0, Color_6);
   }

   int li_0 = TimeCurrent() + 19200;
   for (int l_count_4 = 1; l_count_4 < NumberOfDays; l_count_4++)
   {
      if (Plot_Zone_1) DrawObjects(li_0, "PWT1" + l_count_4, Begin_1, End_1);
      if (Plot_Zone_2) DrawObjects(li_0, "PWT2" + l_count_4, Begin_2, End_2);
      if (Plot_Zone_3) DrawObjects(li_0, "PWT3" + l_count_4, Begin_3, End_3);
      if (Plot_Zone_4) DrawObjects(li_0, "PWT4" + l_count_4, Begin_4, End_4);
      if (Plot_Zone_5) DrawObjects(li_0, "PWT5" + l_count_4, Begin_5, End_5);
      if (Plot_Zone_6) DrawObjects(li_0, "PWT6" + l_count_4, Begin_6, End_6);
      for (li_0 = decDateTradeDay(li_0); TimeDayOfWeek(li_0) > 5; li_0 = decDateTradeDay(li_0), l_count_4--)
      {
      }
   }
   
   ///
   
   if(ShowFutureZone && NofFutureDays > 0)
   {
      lNextDay = incDateTradeDay (TimeCurrent());
      for (i = 1; i <= NofFutureDays; i++)
      {         
         //Print("lNextDay: ", TimeToStr(lNextDay, TIME_DATE | TIME_MINUTES));
         if (Plot_Zone_1) DrawObjectsF(lNextDay, "PWT01" + i, Begin_1, End_1, Color_1);
         if (Plot_Zone_2) DrawObjectsF(lNextDay, "PWT02" + i, Begin_2, End_2, Color_2);
         if (Plot_Zone_3) DrawObjectsF(lNextDay, "PWT03" + i, Begin_3, End_3, Color_3);
         if (Plot_Zone_4) DrawObjectsF(lNextDay, "PWT04" + i, Begin_4, End_4, Color_4);
         if (Plot_Zone_5) DrawObjectsF(lNextDay, "PWT05" + i, Begin_5, End_5, Color_5);
         if (Plot_Zone_6) DrawObjectsF(lNextDay, "PWT06" + i, Begin_6, End_6, Color_6);
         lNextDay = incDateTradeDay(lNextDay);
      }          
   }   
}


///=====================================

void DrawObjects(int ai_0, string a_name_4, string as_12, string as_20)
{
   int l_str2time_28 = StrToTime(TimeToStr(ai_0, TIME_DATE) + " " + as_12);
   int l_str2time_32 = StrToTime(TimeToStr(ai_0, TIME_DATE) + " " + as_20);
   int l_str2time_36 = StrToTime(TimeToStr(ai_0, TIME_DATE) + " " + as_20);
   int l_shift_64 = iBarShift(NULL, 0, l_str2time_28);
   int l_shift_68 = iBarShift(NULL, 0, l_str2time_32);
   int l_shift_72 = iBarShift(NULL, 0, l_str2time_36);
   double l_high_40 = High[iHighest(NULL, 0, MODE_HIGH, l_shift_64 - l_shift_68, l_shift_68)];
   double ld_48 = Low[iLowest(NULL, 0, MODE_LOW, l_shift_64 - l_shift_68, l_shift_68)];
   if (!HighRange)
   {
      l_high_40 = 0;
      ld_48 = 2.0 * ld_48;
   }
   ObjectSet(a_name_4, OBJPROP_TIME1, l_str2time_28);
   ObjectSet(a_name_4, OBJPROP_PRICE1, l_high_40);
   ObjectSet(a_name_4, OBJPROP_TIME2, l_str2time_32);
   ObjectSet(a_name_4, OBJPROP_PRICE2, ld_48);
}

///=====================================
//Draw for future

void DrawObjectsF(int ai_0, string a_name_4, string as_12, string as_20, color pColor)
{
   int l_str2time_28 = StrToTime(TimeToStr(ai_0, TIME_DATE) + " " + as_12);
   int l_str2time_32 = StrToTime(TimeToStr(ai_0, TIME_DATE) + " " + as_20);
   int l_str2time_36 = StrToTime(TimeToStr(ai_0, TIME_DATE) + " " + as_20);
   double l_high_40 = 0;
   double ld_48 = Low[iLowest(NULL, 0, MODE_LOW, 23, 0)];
   ld_48 = 2.0 * ld_48;
   //
   CreateObjects(a_name_4, pColor);
   ObjectSet(a_name_4, OBJPROP_TIME1, l_str2time_28);
   ObjectSet(a_name_4, OBJPROP_PRICE1, l_high_40);
   ObjectSet(a_name_4, OBJPROP_TIME2, l_str2time_32);
   ObjectSet(a_name_4, OBJPROP_PRICE2, ld_48);
}

///=====================================

int decDateTradeDay(int ai_0)
{
   int li_4 = TimeYear(ai_0);
   int li_8 = TimeMonth(ai_0);
   int li_12 = TimeDay(ai_0);
   int l_hour_16 = TimeHour(ai_0);
   int l_minute_20 = TimeMinute(ai_0);
   li_12--;
   if (li_12 == 0) {
      li_8--;
      if (li_8 == 0) {
         li_4--;
         li_8 = 12;
      }
      if (li_8 == 1 || li_8 == 3 || li_8 == 5 || li_8 == 7 || li_8 == 8 || li_8 == 10 || li_8 == 12) li_12 = 31;
      if (li_8 == 2) {
         if (MathMod(li_4, 4) == 0.0) li_12 = 29;
         else li_12 = 28;
      }
      if (li_8 == 4 || li_8 == 6 || li_8 == 9 || li_8 == 11) li_12 = 30;
   }
   return (StrToTime(li_4 + "." + li_8 + "." + li_12 + " " + l_hour_16 + ":" + l_minute_20));
}


//+------------------------------------------------------------------+

datetime incDateTradeDay (datetime dt)
{
   int ty=TimeYear(dt);
   int tm=TimeMonth(dt);
   int td=TimeDay(dt);
   int th=TimeHour(dt);
   int ti=TimeMinute(dt);

   td++;
   if(tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10)
   {
      if(td == 32) {td = 1; tm++;}
   }
   if(tm==12)
   {
      if(td == 32) {td = 1; tm = 1; ty++;}
   }
   if (tm==4 || tm==6 || tm==9 || tm==11)
   {
      if(td == 31) {td = 1; tm++;}
   }
   if (tm==2)
   {
      if(MathMod(ty, 4) == 0)
      {
         if(td == 30) {td = 1; tm++;}
      }
      else
      {
         if(td == 29) {td = 1; tm++;}
      }
   }
     
   return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
}

//+------------------------------------------------------------------+